<?php
include("magic.php");

if (!function_exists('json_encode'))
{
  function json_encode($a=false)
  {
    if (is_null($a)) return 'null';
    if ($a === false) return 'false';
    if ($a === true) return 'true';
    if (is_scalar($a))
    {
      if (is_float($a))
      {
        // Always use "." for floats.
        return floatval(str_replace(",", ".", strval($a)));
      }

      if (is_string($a))
      {
        static $jsonReplaces = array(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'), array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'));
        return '"' . str_replace($jsonReplaces[0], $jsonReplaces[1], $a) . '"';
      }
      else
        return $a;
    }
    $isList = true;
    for ($i = 0, reset($a); $i < count($a); $i++, next($a))
    {
      if (key($a) !== $i)
      {
        $isList = false;
        break;
      }
    }
    $result = array();
    if ($isList)
    {
      foreach ($a as $v) $result[] = json_encode($v);
      return '[' . join(',', $result) . ']';
    }
    else
    {
      foreach ($a as $k => $v) $result[] = json_encode($k).':'.json_encode($v);
      return '{' . join(',', $result) . '}';
    }
  }
}


# This file will process the received requests from the 'jquery client side' system
switch($_POST['option'])
{
    case 'restart_task': echo restart_task($_POST);break;
    case 'delete_task': echo delete_task($_POST);break;
    default: echo "I don't understand this"; break;
}

function restart_task(array $request)
{
    if (@nntpgrab_schedular_restart_task(stripslashes($request['collectionname']),stripslashes($request['subject']))==true) {
        $status = "Successfully restarted download!";
    } else {
        $status = "Unable to restart download";
    }

    return json_encode(array('status' => $status));
}

function delete_task(array $request)
{
    if (@nntpgrab_schedular_del_task_from_queue(stripslashes($request['collectionname']),stripslashes($request['subject']))==true) {
        if (strlen($request['subject']) > 0) {
            $status = "Successfully deleted items";
        } else {
            $status = "Successfully deleted collection";
        }
    } else {
        $status = "Unable to delete item(s)";
    }

    return json_encode(array('status' => $status));
}

?>

